stages:
  - build

# Build and push the Docker image off of merges to main/master, the main branch,
# and tags. See https://docs.gitlab.com/ee/ci/yaml/#only--except for more
# details on customizing this.
docker-build:
  stage: build
  only:
    # You might want to replace these first two with the one branch name which
    # is your main branch.
    - main
    - master
    - merge_requests
    - tags

  image:
    # An alpine-based image with the `docker` CLI installed.
    name: docker:stable

  # This will run a Docker daemon in a container (Docker-In-Docker), which will
  # be available at thedockerhost:2375. If you make e.g. port 5000 public in Docker
  # (`docker run -p 5000:5000 yourimage`) it will be exposed at thedockerhost:5000.
  services:
   - name: docker:dind
     alias: thedockerhost

  variables:
    # Tell docker CLI how to talk to Docker daemon; see
    # https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#use-docker-in-docker-executor
    DOCKER_HOST: tcp://thedockerhost:2375/
    # Use the overlayfs driver for improved performance:
    DOCKER_DRIVER: overlay2
    # Disable TLS certificates in the Docker-in-Docker daemon, since it's only
    # running locally anyway. See
    # https://about.gitlab.com/blog/2019/07/31/docker-in-docker-with-docker-19-dot-03/
    DOCKER_TLS_CERTDIR: ""

  script:
    # Download bash:
    - apk add --no-cache bash python3 git
    # GitLab has a built-in Docker image registry, whose parameters are set automatically.
    # See https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#using-the-gitlab-contai
    #
    # CHANGEME: You can use some other Docker registry though by changing the
    # login and image name.
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    - python3 docker-build/scripts/builder.py build $EXTRA_BUILD_ARGS "$CI_REGISTRY_IMAGE"
    - python3 docker-build/scripts/builder.py push "$CI_REGISTRY_IMAGE"

# IMPORTANT: The above will reuse cached layers indefinitely, which means you
# will not get security updates (see
# https://pythonspeed.com/articles/docker-cache-insecure-images/). To fix that,
# you will need to manually set up a weekly build. See the README for instructions.
